/**
 * Dream
 * Copyright (C) 2003-2004 INRIA Rhone-Alpes
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact: dream@objectweb.org
 *
 * Initial developer(s): Matthieu Leclercq
 * Contributor(s): 
 */

package org.objectweb.dream.adl.checker;

import org.objectweb.fractal.adl.ADLException;
import org.objectweb.fractal.fraclet.annotation.annotations.Interface;

/**
 * Component interface to check that the ADL description of a component is
 * conform to its implementation.
 */
@Interface(name = Checker.ITF_NAME)
public interface Checker
{
  /** The commonly used name of refer to this interface. */
  String ITF_NAME = "checker";
  
  /**
   * Check that the ADL description of the specified component is conform to its
   * implementation.
   * 
   * @param component the component.
   * @param node the AST of its ADL description.
   * @throws ADLException if the ADL description is not conform to the
   *           component's implementation.
   */
  void check(Object component, Object node) throws ADLException;
}